"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMocker = createMocker;
const tslib_1 = require("tslib");
const koa_1 = tslib_1.__importDefault(require("koa"));
const koa_mount_1 = tslib_1.__importDefault(require("koa-mount"));
const openapi_backend_1 = tslib_1.__importDefault(require("openapi-backend"));
function createMocker({ spec }) {
    const mocker = new openapi_backend_1.default({
        definition: spec,
        handlers: {
            notImplemented({ api, operation: { operationId } }, context) {
                const { status, mock } = api.mockResponseForOperation(operationId);
                context.status = status;
                context.body = mock;
            }
        }
    });
    mocker.init();
    const app = new koa_1.default().use(context => mocker.handleRequest(context.request, context));
    return () => (0, koa_mount_1.default)('/mock', app);
}
