"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSwagger = createSwagger;
const tslib_1 = require("tslib");
const routing_controllers_1 = require("routing-controllers");
const routing_controllers_openapi_1 = require("routing-controllers-openapi");
// @ts-ignore
const storage_1 = require("class-transformer/cjs/storage");
const class_validator_jsonschema_1 = require("class-validator-jsonschema");
const koa2_swagger_ui_1 = require("koa2-swagger-ui");
function createSwagger({ controllers }) {
    const router = { controllers }, schemas = (0, class_validator_jsonschema_1.validationMetadatasToSchemas)({
        classTransformerMetadataStorage: storage_1.defaultMetadataStorage,
        refPointerPrefix: '#/components/schemas/'
    });
    const spec = (0, routing_controllers_openapi_1.routingControllersToSpec)((0, routing_controllers_1.getMetadataArgsStorage)(), router, {
        components: { schemas }
    });
    const swagger = (_a = {}) => {
        var { swaggerOptions } = _a, opitons = tslib_1.__rest(_a, ["swaggerOptions"]);
        // @ts-expect-error Type compatibility between koa2-swagger-ui & routing-controllers-openapi
        return (0, koa2_swagger_ui_1.koaSwagger)(Object.assign({ swaggerOptions: Object.assign({ spec }, swaggerOptions) }, opitons));
    };
    return { router, schemas, spec, swagger };
}
