import { SwaggerOptions } from './Swagger';
export * from './Swagger';
export * from './Mocker';
export interface APIOptions extends SwaggerOptions {
    mock?: boolean;
}
export declare function createAPI({ controllers, mock }: APIOptions): {
    mocker: () => import("koa").Middleware<import("koa").DefaultState, import("koa").DefaultContext, any>;
    router: {
        controllers: (new (...data: any[]) => any)[];
    };
    schemas: Record<string, import("openapi3-ts").SchemaObject>;
    swagger: ({ swaggerOptions, ...opitons }?: Partial<import("koa2-swagger-ui").KoaSwaggerUiOptions>) => import("koa").Middleware;
    spec: import("openapi3-ts").OpenAPIObject;
};
